makewhatis: scan for potentially missing MLINKS in verbose mode
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 MORE ISA SUPPORT DROPPED
16 ------------------------
17
18 ISA support has been dropped from the following drivers: adv(4), an(4),
19 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
20 si(4), sn(4), and stg(4).
21
22 +-----------------------------------------------------------------------+
23 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
24 +-----------------------------------------------------------------------+
25
26 ABI CHANGE
27 ----------
28
29 Installed third-party software (dports) will have to be rebuilt after upgrade,
30 or reinstalled from binary packages.
31
32 UPDATING FROM 3.4 TO 3.6
33 ------------------------
34
35 This only applies for this specific upgrade due to locale changes; it is 
36 not needed for upgrades after 3.6.  Please update in this order:
37
38 make buildworld
39 make buildkernel
40 make installworld
41 make installkernel
42 *reboot*
43 make upgrade
44
45 See this mailing list post for details:
46 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
47
48 CYRIX OPTIONS REMOVED
49 ---------------------
50
51 The following Cyrix related options have been removed: CPU_BTB_EN,
52 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
53 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
54 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
55
56 ISA SUPPORT REMOVED FROM RP(4)
57 ------------------------------
58
59 ISA support has been removed from the rp(4) driver. It is now PCI only.
60
61 +-----------------------------------------------------------------------+
62 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
63 +-----------------------------------------------------------------------+
64
65 COMPAT_SUNOS OPTION REMOVED
66 ---------------------------
67
68 The COMPAT_SUNOS option has been removed. It was meant to provide binary
69 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
70
71 ISA SOUND CARD SUPPORT REMOVED
72 ------------------------------
73
74 The following modules have been removed (all for ISA sound cards):
75 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
76
77 GCC 4.7
78 -------
79
80 DragonFly has switched base compilers.  GCC 4.7 is now the default
81 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
82 variable ceases to work now.
83
84 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
85 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
86 highly discouraged.  There are a few packages in pkgsrc that do not build
87 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
88 this time, it is recommended to keep both compilers on the base system.
89
90 SMP OPTION REMOVED
91 ------------------
92
93 The SMP kernel option has been made a no-op. All kernels now feature SMP
94 support. If you have 'options SMP' in your kernel config, you can as well
95 remove it.
96
97 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
98 ---------------------------------------------------------------------------
99
100 The DEVICE_POLLING kernel option has been made a no-op and it has been
101 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
102 kernel config, you need to change it to IFPOLL_ENABLE.
103
104 Also, the KTR_POLLING kernel option has been removed, so it must be
105 removed from kernel configs that have it.
106
107 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
108 ---------------------------------------------------
109
110 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
111 cards will no longer be detected.
112
113 The same has been done for Stallion multiport serial controllers. stli(4)
114 has been completely removed (along with the stlload(8) and stlstty(8)
115 utilities) and stl(4) was changed to support only PCI cards. Similarly,
116 ISA support was removed from cy(4) too. All these drivers are i386 only.
117
118 COMPAT_OLDISA OPTION GONE
119 -------------------------
120
121 The i386 specific COMPAT_OLDISA kernel option has been removed, since
122 nothing needs it anymore.
123
124 +-----------------------------------------------------------------------+
125 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
126 +-----------------------------------------------------------------------+
127
128 APIC_IO OPTION REMOVED
129 ----------------------
130
131 The APIC_IO kernel option is no longer accepted after having been without
132 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
133 If you have 'options APIC_IO' in your kernel config, you'll have to
134 remove it.
135
136 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
137 -----------------------------------------
138
139 The wdog framework is now compiled into our kernels by default, so the
140 options are no longer needed.
141
142 DOSCMD(1) REMOVED
143 -----------------
144
145 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
146 NO_X make.conf option was removed too.
147
148 GCC 4.7
149 -------
150
151 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
152 default compiler in base (default is still GCC 4.4).
153
154 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
155 NO_GCC47 in /etc/make.conf.
156
157 USB4BSD
158 -------
159
160 A new USB stack (from FreeBSD) has been brought in. The following
161 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
162 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
163 and uaudio.
164
165 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
166 be put in make.conf and device "usb4bsd" (quotes needed) has to
167 replace device usb in the kernel config. After that, a full
168 build/install/upgrade cycle is needed.
169
170 Note that this is experimental and incomplete, but we are interested
171 in hearing about issues with it, of course.
172
173 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
174 ---------------------------------------------
175
176 ISA adapter support was dropped from the aic(4) driver.
177
178 +-----------------------------------------------------------------------+
179 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
180 +-----------------------------------------------------------------------+
181
182 SEVERAL ISA DRIVERS REMOVED
183 ---------------------------
184
185 The following ISA only drivers have been removed along with a couple of
186 associated userland tools:
187
188 aha(4)
189 asc(4) & sasc(1)
190 ctx
191 dgb(4)
192 el(4)
193 gpib
194 gsc(4) & sgsc(1)
195 ie(4)
196 labpc(4)
197 le(4)
198 mse(4)
199 rc(4)
200 rdp(4)
201 spigot
202 tw(4) & xten(1) & xtend(8)
203 wl(4) & wlconfig(8)
204 wt(4)
205
206 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
207 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
208 file.
209
210 If buildkernel complains about any of these drivers, just remove them
211 from your kernel configuration.
212
213 BINUTILS 2.20
214 -------------
215 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
216 values of BINUTILSVERS are now binutils221 and binutils222 (default).
217
218 BUILDWORLD/-KERNEL PARALLELIZATION WORK
219 ---------------------------------------
220 Due to changes in the way we build with more than one make job, you
221 will have to update install(1) and mkdir(1) prior to buildworld if you
222 want to build with 'make -j':
223
224 cd /usr/src/usr.bin/xinstall; make; make install; make clean
225 cd /usr/src/bin/mkdir; make; make install; make clean
226
227 DMA(8) UPGRADE
228 --------------
229 dma(8) has been upgraded to v0.7 which no longer supports the
230 /etc/dma/virtusertable. Some of its functionality has been replaced
231 with the MASQUERADE keyword and the EMAIL environment variable (see
232 the dma(8) manual page).
233
234 +-----------------------------------------------------------------------+
235 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
236 +-----------------------------------------------------------------------+
237
238 GCC 4.4 & BINUTILS 2.21
239 -----------------------
240
241 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
242 been made DragonFly's default Binutils.
243
244 That means that any settings that set CCVER to 'gcc44' are not needed
245 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
246 GCC 4.1.
247
248 It also means that 'binutils221' as a value for BINUTILSVER has no
249 effect anymore. 2.17 has been removed and 'binutils220' is available
250 as an option.
251
252 The NO_GCC44 option has been removed and will not affect the build
253 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
254 building in a similar fashion.
255
256 Note that you must do a full buildworld/buildkernel for upgrading.
257
258 pkg_radd settings
259 -----------------
260
261 The config file for pkg_radd has moved from /etc/settings.conf to 
262 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
263 if this is needed.  This warning only applies if /etc/settings.conf 
264 exists.  pkg_radd will continue to work with defaults.
265
266 +-----------------------------------------------------------------------+
267 +         20100927                                                      +
268 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
269 +-----------------------------------------------------------------------+
270
271 OpenSSL
272 --------
273
274 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
275 This shouldn't break any 3rd-party software, but you'll need to recompile your
276 3rd-party software if you want it to link against the new version of OpenSSL.
277
278 Loader
279 -------
280
281 A new loader (dloader) has been added which better handles booting from
282 multiple kernel/module versions.
283
284 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
285
286         cd /usr/src
287         make buildworld
288         make installworld
289         make upgrade
290         make buildkernel KERNCONF=<KERNELNAME>
291         make installkernel KERNCONF=<KERNELNAME>
292
293 Note that you must installworld and run the 'upgrade' target before
294 installing the new kernel.
295
296 BIND
297 -----
298
299 BIND has been removed from the base system.  The ldns and drill tools have 
300 been added for basic functionality.  Use 'drill' where you would normally 
301 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
302 net/bind95, net/bind96, or net/bind97 as of this writing.
303
304 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
305 include BIND as a pkgsrc package.
306
307 +-----------------------------------------------------------------------+
308 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
309 +                               GENERAL                                 +
310 +-----------------------------------------------------------------------+
311
312 Instructions on how to obtain and maintain DragonFly source code using git
313 are in the development(7) manual page.
314
315 To upgrade a DragonFly system from sources you run the following sequence:
316
317         cd /usr/src
318         make buildworld
319         make buildkernel KERNCONF=<KERNELNAME>
320         make installkernel KERNCONF=<KERNELNAME>
321         make installworld
322
323 You will also want to run the 'upgrade' target to upgrade your /etc and the
324 rest of your system.  The upgrade target is aware of stale files created by
325 older DragonFly installations and should delete them automatically.
326
327         make upgrade
328
329 See the build(7) manual page for further information.
330
331 Once you've done a full build of the world and kernel you can do incremental
332 upgrades of either by using the 'quickworld' and 'quickkernel' targets
333 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
334 the quick targets, try updating your repo first, and then a full buildworld
335 and buildkernel as shown above, before asking for help.
336
337 +-----------------------------------------------------------------------+
338 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
339 +-----------------------------------------------------------------------+
340
341 In 2.1 kernel and modules has moved to boot directory.  For most cases
342 this is handled automatically by 'make upgrade'.  A few cases needs manual
343 intervention:
344
345  * When installing a kernel without first doing a make buildworld,
346    installworld and upgrade to the same DESTDIR as kernel:
347    make DESTDIR/boot directory and move kernel and modules into this boot
348    directory; also move kernel.old and modules.old.
349    Typical example is vkernel(7), use (no modules used):
350
351         cd /var/vkernel
352         mkdir boot
353         chflags noschg kernel
354         mv kernel kernel.old boot
355         chflags schg boot/kernel
356         
357  * When using a boot-only partition, /boot/loader.rc needs to be edited:
358    delete occurrences of '/boot/'.
359    These occurences can normally be deleted in any case, see loader(8).
360
361 +-----------------------------------------------------------------------+
362 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
363 +-----------------------------------------------------------------------+
364
365 In 1.9 major changes to the disk management infrastructure have taken
366 place.  make upgrade may not catch all of your disk devices in /dev,
367 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
368 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
369 and MAKEDEV no longer exists.
370
371 The biggest changes in 1.9 are:
372
373 (1) That whole-slice devices such as da0s1 no longer share the same device
374     id as partition c devices such as da0s1c.
375
376 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
377     with no snooping or reserved sectors.  Consequently you cannot run
378     disklabel on this device.  Instead you must run disklabel on a
379     whole-slice device.
380
381 (3) The 'compatibility' partitions now use slice 0 in the device name,
382     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
383     accessing the disklabel for the compatibility partitions must be
384     done via slice 0 (da0s0).
385
386 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
387     and CCD now run through the disk management layer and are assigned
388     real disk management devices.   VN and CCD in particular do not usually
389     use a MBR and disklabels must be accessed through the compatibility
390     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
391     don't name it 'ccd0s0' in the config file.
392
393 Generally speaking, you have to get used to running fdisk and disklabel on
394 the correctly specified device names.  A lot of the wiggle, such as running
395 disklabel on a partition, has been removed.
396
397 +-----------------------------------------------------------------------+
398 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
399 +-----------------------------------------------------------------------+
400
401 > Kerberos IV
402 -------------
403
404 Kerberos IV (eBones) was removed from the tree, please consider moving to
405 Kerberos 5 (Heimdal).
406
407 > Package Management System
408 ---------------------------
409
410 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
411 management system.  The necessary tools to build and maintain packages
412 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
413 directories are in your PATH variable.
414
415 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
416 the tarball from NetBSD:
417
418         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
419         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
420
421 This tree can then be kept up to date with cvs update:
422
423         cd /usr/pkgsrc; cvs up
424
425 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
426 build and install the pkgsrc bootstrap manually:
427
428         cd /usr/pkgsrc/bootstrap
429         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
430
431 +-----------------------------------------------------------------------+
432 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
433 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
434 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
435 +-----------------------------------------------------------------------+
436
437 The compatibility shims for the build environment have been removed, you
438 have to update to DragonFly 1.2 release branch first.
439
440 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
441 The existing configuration can be converted using /etc/pam.d/convert.sh.
442 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
443 the pam_skey.so module was retired, you have to remove it manually from
444 your configuration, when you convert it.
445
446 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
447 ---------------------
448
449 The following users may be missing from your password file.  Use vipw and
450 add any that are missing:
451
452 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
453 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
454
455 The following groups may be missing from your group file.  Use vi /etc/group
456 and add any that are missing:
457
458 smmsp:*:25:
459 authpf:*:63:
460 _pflogd:*:64:
461
462
463 > Upgrading to DragonFly from FreeBSD
464 ---------------------
465
466 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
467 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
468 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
469 make depend information, it starts from scratch, so no pre-cleaning of the
470 object hierarchy is necessary.
471
472         # get the CVS repository (it is placed in /home/dcvs, 500MB).
473         # Please use the -h option and a mirror site to pull the 
474         # initial repository, but feel free to use the main repository
475         # machine to pull updates.
476         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
477         # install the source from the CVS hierarchy (remove preexisting
478         # FreeBSD src first) (500MB)
479         cd /usr
480         rm -rf src
481         cvs -R -d /home/dcvs checkout -P src
482
483         # build it (500MB used in /usr/obj)
484         #
485         cd /usr/src
486         make buildworld
487         make buildkernel KERNCONF=<KERNELNAME>
488
489 Once you have built DragonFly you have to install it over FreeBSD.  Since
490 DragonFly does not track changes made by FreeBSD to its include file 
491 hierarchy and include file pollution can cause all sorts of unexpected
492 compilation issues to come up, it is best to wipe your include hierarchy
493 prior to installing DragonFly.  Note that you should not wipe any installed
494 FreeBSD header files or binaries until after you have successfully completed
495 the build steps above.
496
497         rm -rf /usr/include
498         mkdir /usr/include
499         make installkernel KERNCONF=<KERNELNAME>
500         make installworld
501
502 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
503 will unconditionally upgrade the /etc files that sysops do not usually
504 mess around with, such as the files in /etc/rc.d.  It will also remove any
505 obsolete files such as utilities and manpages that have been removed from
506 the system since the version you're coming from.  If you are unsure we 
507 recommend that you make a backup of at least your /etc before applying
508 this step.  Note that DragonFly's RC system is basically RCNG from
509 FreeBSD-5, but there are some differences in the contents of the RC files.
510
511         make upgrade
512
513 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
514 Doing so might leave your system in an unusable state.
515
516 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
517 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
518 report these files to the DragonFly developers so that they can be added to
519 the 'upgrade' target.
520